"use strict";

var buildNode = require('../utils/buildNode');

var attributes = ['size', 'width', 'height', 'path', 'format', 'isImage', 'createdAt', 'notes', 'author', 'copyright', 'defaultFieldMetadata', 'tags', 'smartTags', 'filename', 'basename', 'exifInfo', 'mimeType', 'blurhash', 'colors', 'muxPlaybackId', 'muxMp4HighestRes', 'frameRate', 'duration'];

module.exports = function buildUploadNode(entity, _ref) {
  var entitiesRepo = _ref.entitiesRepo;
  var siteEntity = entitiesRepo.findEntitiesOfType('site')[0];
  var imgixHost = "https://".concat(siteEntity.imgixHost);
  return buildNode('DatoCmsAsset', entity.id, function (node) {
    attributes.forEach(function (attribute) {
      node[attribute] = entity[attribute];
    });
    node.originalId = entity.id;
    node.url = "".concat(imgixHost).concat(entity.path);
  });
};