"use strict";

var _require = require('humps'),
    camelize = _require.camelize;

module.exports = function (_ref) {
  var parentItemType = _ref.parentItemType,
      field = _ref.field,
      schema = _ref.schema,
      gqlItemTypeName = _ref.gqlItemTypeName,
      entitiesRepo = _ref.entitiesRepo;
  var fieldKey = camelize(field.apiKey);
  return {
    fieldType: 'String',
    nodeFieldType: {
      type: 'DatoCmsTextNode',
      allLocalesResolver: function allLocalesResolver(parent) {
        return parent.valueNode___NODE;
      },
      normalResolver: function normalResolver(parent) {
        return parent["".concat(fieldKey, "Node___NODE")];
      },
      resolveFromValue: function resolveFromValue(id, args, context) {
        if (id) {
          return context.nodeModel.getNodeById({
            id: id
          });
        }
      }
    }
  };
};